package info.kofler

import org.jetbrains.exposed.dao.*
import org.jetbrains.exposed.dao.id.*
import org.jetbrains.exposed.dao.id.EntityID

object Urls : IntIdTable() {
    // MySQL lässt nur Indizes für Textspalten mit bis zu 3072 Byte zu
    // da UTF8, kostet ein Zeichen theoretisch 3 Byte
    val fullurl = varchar("fullurl", 1000).index()
    val shortcode = varchar("shortcode", 10).index()
}

class Url(id: EntityID<Int>): IntEntity(id) {
    companion object : IntEntityClass<Url>(Urls)
    var fullurl by Urls.fullurl
    var shortcode by Urls.shortcode
}