package info.kofler.evalclient

import android.content.Context
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import androidx.navigation.findNavController
import androidx.navigation.ui.NavigationUI
import info.kofler.evalclient.databinding.ActivityMainBinding

class Actv_Main : AppCompatActivity() {

    private lateinit var binding: ActivityMainBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityMainBinding.inflate(layoutInflater)
        setContentView(binding.root)

        // Nur zum Debugging: Reset für gespeicherte Login-Daten
        // val pref = getPreferences(Context.MODE_PRIVATE)
        // pref.edit().putString("studentId", "").apply()
        // pref.edit().putString("appkey", "").apply()

        // gemeinsame Daten initialisieren
        if (!shared.isInitialized) {
            val pref = getPreferences(Context.MODE_PRIVATE)
            shared.studentNo = pref.getString("studentId", "") ?: ""
            shared.appkey = pref.getString("appkey", "") ?: ""
            // println("xxx studentNo = ${shared.studentNo},  appkey = ${shared.appkey}")
            // println("xxx fingerprint = ${Build.FINGERPRINT}")
            // println("xxx isEmulator = ${isEmulator()}")
            shared.isInitialized = true
            // authClient-Variable neu initialisieren
            authClient = setupAuthClient(shared.studentNo,
                                         shared.appkey)
        }

        // Navigation Controller einrichten
        binding.fragHost.post {
            val navCtrl = findNavController(R.id.fragHost)
            NavigationUI.setupActionBarWithNavController(this, navCtrl)
        }
    }

    // Rückwärts-Navigation mit dem Up-Button
    override fun onSupportNavigateUp(): Boolean {
        val navCtr = findNavController(R.id.fragHost)
        return navCtr.navigateUp()
    }
}
