package info.kofler.evalclient

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ProgressBar
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import info.kofler.evalclient.databinding.ItemEvalresultBinding

class Holder_EvalResult(binding: ItemEvalresultBinding) : RecyclerView.ViewHolder(binding.root) {
    val question: TextView = binding.lblQuestion  // -> layout/res/item_evalresult.xml
    val progress: ProgressBar = binding.progressBar
    val info: TextView = binding.lblInfo
}

class Adapter_EvalResult(private val items: List<EvaluationItem>,
                         private val context: Context)
    : RecyclerView.Adapter<Holder_EvalResult>()
{
    // Anzahl der Elemente
    override fun getItemCount() = items.count()

    // leere Listenelemente erzeugen
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): Holder_EvalResult {
        val binding = ItemEvalresultBinding.inflate(
            LayoutInflater.from(parent.context), parent, false)
        return Holder_EvalResult(binding)
    }

    // Listenelemente mit Daten befüllen
    override fun onBindViewHolder(holder: Holder_EvalResult, position: Int) {
        val item = items[position]
        holder.question.text = item.question
        if (item.qtype == "range") {
            holder.progress.progress = item.nmb ?: 0
            holder.progress.visibility = View.VISIBLE
            holder.info.visibility = View.INVISIBLE
        } else {
            holder.progress.visibility = View.INVISIBLE
            holder.info.visibility = View.VISIBLE
        }
    }


}