package info.kofler.evalclient

import android.os.Bundle
import android.util.Log
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import info.kofler.evalclient.databinding.FragmentEvalResultBinding
import io.ktor.client.request.get
import kotlinx.coroutines.*
import java.lang.Exception

class Frag_EvalResult : Fragment(), CoroutineScope by MainScope() {
    private var _binding: FragmentEvalResultBinding? = null
    // This property is only valid between onCreateView and
    // onDestroyView!
    private val binding get() = _binding!!

    // vorerst leeres EvaluationDetails-Objekt, wird später mit
    // richtigen Daten initialisiert
    private var evalDetails = EvaluationDetails(-1, "", listOf())

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?): View
    {
        _binding = FragmentEvalResultBinding.inflate(inflater, container, false)
        binding.rclEvalresult.adapter = Adapter_EvalResult(listOf(), requireContext())
        binding.rclEvalresult.layoutManager = LinearLayoutManager(context)
        val divider = DividerItemDecoration(context, DividerItemDecoration.VERTICAL)
        binding.rclEvalresult.addItemDecoration(divider)
        getEvalResults()
        return binding.root
    }
    override fun onDestroy() {
        super.onDestroy()
        cancel()  // Hintergrundprozesse stoppen
    }

    // Evaluierungsdetails (also Fragestellung) ermitteln
    private fun getEvalResults() {
        launch(Dispatchers.IO) {
            try {
                val evalId = shared.evalId
                evalDetails = authClient.get("$evalhost/api/results/$evalId")
                launch(Dispatchers.Main) {
                    binding.lblEvalresultname.text = evalDetails.course
                    // neue Instanz in evalDetails, daher neuer Adapter
                    binding.rclEvalresult.adapter =
                        Adapter_EvalResult(evalDetails.items,
                            requireContext())
                }
            } catch (e: Exception) {
                Log.e("xxx", "Frag_EvalResult, getEvalResults: $e")
            }
        }
    }
}